PostgreSQL 7.1.3 Documentation
Prev | Chapter 1. Installation Instructions | Next

# 1.5. Installation Procedure

1. Configuration

   The first step of the installation procedure is to configure the source tree for your system and choose the options you would like. This is done by running the `configure` script. For a default installation simply enter

       ./configure

   This script will run a number of tests to guess values for various system dependent variables and detect some quirks of your operating system, and finally creates several files in the build tree to record what it found.

   The default configuration will build the server and utilities, as well as all client applications and interfaces that only require a C compiler. All files will be installed under `/usr/local/pgsql` by default.

   You can customize the build and installation process by supplying one or more of the following command line options to `configure`:

   --prefix=`PREFIX`

     Install all files under the directory `PREFIX` instead of `/usr/local/pgsql`. The actual files will be installed into various subdirectories; no files will ever be installed directly into the `PREFIX` directory.

     If you have special needs, you can also customize the individual subdirectories with the following options.

   --exec-prefix=`EXEC-PREFIX`

     You can install architecture-dependent files under a different prefix, `EXEC-PREFIX`, than what `PREFIX` was set to. This can be useful to share architecture-independent files between hosts. If you omit this, then `EXEC-PREFIX` is set equal to `PREFIX` and both architecture dependent and independent files will be installed under the same tree, which is probably what you want.

   --bindir=`DIRECTORY`

     Specifies the directory for executable programs. The default is ``EXEC-PREFIX`/bin`, which normally means `/usr/local/pgsql/bin`.

   --datadir=`DIRECTORY`

     Sets the directory for read-only data files used by the installed programs. The default is ``PREFIX`/share`. Note that this has nothing to do with where your database files will be placed.

   --sysconfdir=`DIRECTORY`

     The directory for various configuration files, ``PREFIX`/etc` by default.

   --libdir=`DIRECTORY`

     The location to install libraries and dynamically loadable modules. The default is ``EXEC-PREFIX`/lib`.

   --includedir=`DIRECTORY`

     The directory for installing C and C++ header files. The default is ``PREFIX`/include`.

   --docdir=`DIRECTORY`

     Documentation files, except "man" pages, will be installed into this directory. The default is ``PREFIX`/doc`.

   --mandir=`DIRECTORY`

     The man pages that come with PostgreSQL will be installed under this directory, in their respective `man`x`` subdirectories. The default is ``PREFIX`/man`.

   > Note: To reduce the pollution of shared installation locations (such as `/usr/local/include`), the string "`/postgresql`" is automatically appended to `datadir`, `sysconfdir`, `includedir`, and `docdir`, unless the fully expanded directory name already contains the string "postgres" or "pgsql". For example, if you choose `/usr/local` as prefix, the C header files will be installed in `/usr/local/include/postgresql`, but if the prefix is `/opt/postgres`, then they will be in `/opt/postgres/include`.

   --with-includes=`DIRECTORIES`

     `DIRECTORIES` is a colon-separated list of directories that will be added to the list the compiler searches for header files. If you have optional packages (such as GNU Readline) installed in a non-standard location you have to use this option and probably the corresponding `--with-libraries` option.

     Example: `--with-includes=/opt/gnu/include:/usr/sup/include`.

   --with-libraries=`DIRECTORIES`

     `DIRECTORIES` is a colon-separated list of directories to search for libraries. You will probably have to use this option (and the corresponding `--with-includes` option) if you have packages installed in non-standard locations.

     Example: `--with-libraries=/opt/gnu/lib:/usr/sup/lib`.

   --enable-locale

     Enables locale support. There is a performance penalty associated with locale support, but if you are not in an English-speaking environment you will most likely need this.

   --enable-recode

     Enables single-byte character set recode support. See Section 5.3 about this feature.

   --enable-multibyte

     Allows the use of multibyte character encodings. This is primarily for languages like Japanese, Korean, and Chinese. Read Section 5.2 for details.

   --with-pgport=`NUMBER`

     Set `NUMBER` as the default port number for server and clients. The default is 5432. The port can always be changed later on, but if you specify it here then both server and clients will have the same default compiled in, which can be very convenient.

   --with-CXX

     Build the C++ interface library.

   --with-perl

     Build the Perl interface module. The Perl interface will be installed at the usual place for Perl modules (typically under `/usr/lib/perl`), so you must have root access to perform the installation step (see step 4). You need to have Perl 5 installed to use this option.

   --with-python

     Build the Python interface module. You need to have root access to be able to install the Python module at its default place (`/usr/lib/python`x`.`y``). To be able to use this option, you must have Python installed and your system needs to support shared libraries. If you instead want to build a new complete interpreter binary, you will have to do it manually.

   --with-tcl

     Builds components that require Tcl/Tk, which are libpgtcl, pgtclsh, pgtksh, pgaccess, and PL/Tcl. But see below about `--without-tk`.

   --without-tk

     If you specify `--with-tcl` and this option, then programs that require Tk (i.e., pgtksh and pgaccess) will be excluded.

   --with-tclconfig=`DIRECTORY`, --with-tkconfig=`DIRECTORY`

     Tcl/Tk installs the files `tclConfig.sh` and `tkConfig.sh` which contain certain configuration information that is needed to build modules interfacing to Tcl or Tk. These files are normally found automatically at their well-known location, but if you want to use a different version of Tcl or Tk you can specify the directory where to find them.

   --enable-odbc

     Build the ODBC driver package.

   --with-odbcinst=`DIRECTORY`

     Specifies the directory where the ODBC driver will expect its `odbcinst.ini` configuration file. The default is `/usr/local/pgsql/etc` or whatever you specified as `--sysconfdir`. A default file will be installed there. If you intend to share the `odbcinst.ini` file between several ODBC drivers then you may want to use this option.

   --with-krb4=`DIRECTORY`, --with-krb5=`DIRECTORY`

     Build with support for Kerberos authentication. You can use either Kerberos version 4 or 5, but not both. The `DIRECTORY` argument specifies the root directory of the Kerberos installation; `/usr/athena` is assumed as default. If the relevant headers files and libraries are not under a common parent directory, then you must use the `--with-includes` and `--with-libraries` options in addition to this option. If, on the other hand, the required files are in a location that is searched by default (e.g., `/usr/lib`), then you can leave off the argument.

     `configure` will check for the required header files and libraries to make sure that your Kerberos installation is sufficient before proceeding.

   --with-krb-srvnam=`NAME`

     The name of the Kerberos service principal. "postgres" is the default. There's probably no reason to change this.

   --with-openssl=`DIRECTORY`

     Build with support for SSL (encrypted) connections. This requires the OpenSSL package to be installed. The `DIRECTORY` argument specifies the root directory of the OpenSSL installation; the default is `/usr/local/ssl`.

     `configure` will check for the required header files and libraries to make sure that your OpenSSL installation is sufficient before proceeding.

   --with-java

     Build the JDBC driver and associated Java packages. This option requires Ant to be installed (as well as a JDK, of course). Refer to the JDBC driver documentation in the Programmer's Guide for more information.

   --enable-syslog

     Enables the PostgreSQL server to use the syslog logging facility. (Using this option does not mean that you must log with syslog or even that it will be done by default, it simply makes it possible to turn this option on at run time.)

   --enable-debug

     Compiles all programs and libraries with debugging symbols. This means that you can run the programs through a debugger to analyze problems. This enlarges the size of the installed executables considerably, and on non-gcc compilers it usually also disables compiler optimization, causing slowdowns. However, having the symbols available is extremely helpful for dealing with any problems that may arise. Currently, this option is considered of marginal value for production installations, but you should have it on if you are doing development work or running a beta version.

   --enable-cassert

     Enables assertion checks in the server, which test for many "can't happen" conditions. This is invaluable for code development purposes, but the tests slow things down a little. Also, having the tests turned on won't necessarily enhance the stability of your server! The assertion checks are not categorized for severity, and so what might be a relatively harmless bug will still lead to postmaster restarts if it triggers an assertion failure. Currently, this option is not recommended for production use, but you should have it on for development work or when running a beta version.

   If you prefer a C or C++ compiler different from the one `configure` picks then you can set the environment variables `CC` and `CXX`, respectively, to the program of your choice. Similarly, you can override the default compiler flags with the `CFLAGS` and `CXXFLAGS` variables. For example:

       env CC=/opt/bin/gcc CFLAGS='-02 -pipe' ./configure

2. Build

   To start the build, type

       gmake

   (Remember to use GNU make.) The build can take anywhere from 5 minutes to half an hour. The last line displayed should be

       All of PostgreSQL is successfully made. Ready to install.

3. Regression Tests

   If you want to test the newly built server before you install it, you can run the regression tests at this point. The regression tests are a test suite to verify that PostgreSQL runs on your machine in the way the developers expected it to. Type

       gmake check

   It is possible that some tests fail, due to differences in error message wording or floating point results. Chapter 12 contains detailed information about interpreting the test results. You can repeat this test at any later time by issuing the same command.

4. Installing The Files

   > Note: If you are upgrading an existing system and are going to install the new files over the old ones then you should have backed up your data and shut down the old server by now, as explained in Section 1.4 above.

   To install PostgreSQL enter

       gmake install

   This will install files into the directories that were specified in step 1. Make sure that you have appropriate permissions to write into that area. Normally you need to do this step as root. Alternatively, you could create the target directories in advance and arrange for appropriate permissions to be granted.

   If you built the Perl or Python interfaces and you were not the root user when you executed the above command then that part of the installation probably failed. In that case you should become the root user and then do

       gmake -C src/interfaces/perl5 install
       gmake -C src/interfaces/python install

   Due to a quirk in the Perl build environment the first command will actually rebuild the complete interface and then install it. This is not harmful, just unusual. If you do not have superuser access you are on your own: you can still take the required files and place them in other directories where Perl or Python can find them, but how to do that is left as an exercise.

   The standard install installs only the header files needed for client application development. If you plan to do any server-side program development (such as custom functions or datatypes written in C), then you may want to install the entire PostgreSQL include tree into your target include directory. To do that, enter

       gmake install-all-headers

   This adds a megabyte or two to the install footprint, and is only useful if you don't plan to keep the whole source tree around for reference. (If you do, you can just use the source's include directory when building server-side software.)

   Client-only installation. If you want to install only the client applications and interface libraries, then you can use these commands:

       gmake -C src/bin install
       gmake -C src/interfaces install
       gmake -C doc install

   To undo the installation use the command gmake uninstall. However, this will not remove the Perl and Python interfaces and it will not remove any directories.

After the installation you can make room by removing the built files from the source tree with the gmake clean command. This will preserve the choices made by the configure program, so that you can rebuild everything with gmake later on. To reset the source tree to the state in which it was distributed, use gmake distclean. If you are going to build for several platforms from the same source tree you must do this and re-configure for each build.

Prev | Home | Next
If You Are Upgrading | Up | Post-Installation Setup